/*
 * Nouvelle version de xorglue.
 *
 * Sylvain Pion, Octobre 1996.
 */

/*
 * Prend en argument:
 * - la taille des fichiers.
 * - le "modulo" == le nombre de fichiers Xor.
 * - le nombre de fichiers de base.
 * (precedemment testes par un script avec md5)
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>


int main(int argc, char **argv)
{
  int i, j, k, w, swap_size;
  FILE *current_file;
  unsigned char *swap, e;
  char file_name[32];
  int temp;
  int file_size = atoi(argv[1]);
  int xor_file_nb = atoi(argv[2]);
  int base_file_nb = atoi(argv[3]);
  int nb_files_to_avoid;
  int file_to_avoid[100000];

/* On charge les numros foireux. */

  current_file = fopen("diffxor","r");
  nb_files_to_avoid=0;
  while (fscanf(current_file,
                "md5sum: MD5 check failed for 'xor%d'\n",
                &file_to_avoid[nb_files_to_avoid])
         != EOF)
    nb_files_to_avoid++;
  printf("%d fichier(s) cass(s).\n", nb_files_to_avoid);
  file_to_avoid[nb_files_to_avoid] = -1;
  fclose(current_file);

/* On alloue la mmoire de travail. */

  swap_size = file_size * xor_file_nb;
  if ((swap = malloc(swap_size)) == NULL)
  {
    printf("Impossible d'allouer la mmoire ncessaire\n");
    exit(-1);
  };

/* On la met  zro. */

  for (i=0; i<swap_size; i++) swap[i]=0;

/* On fait la boucle de lecture des fichiers de base. */

  for (i=j=w=0; i<base_file_nb; i++)
  {
    if (i == file_to_avoid[w])
    {
      ++w;
      j += file_size; 
    }
    else
    {
      sprintf(file_name, "xor%d", i);
      current_file = fopen(file_name, "r");
      while ((temp = getc(current_file)) != EOF)
      {
        e = temp;
        swap[j % swap_size] ^= e;
        ++j;
      };
      fclose(current_file);
    };
  };

/* Idem avec les fichiers de Xor. */

  for (i=j=0; i<xor_file_nb; i++)
  {
    if (i == file_to_avoid[w])
    {
      ++w;
      j += file_size;
    }
    else
    {
      sprintf(file_name, "xor%d", i + base_file_nb);
      current_file = fopen(file_name, "r");
      while ((temp = getc(current_file)) != EOF)
      {
        e = temp;
        swap[j % swap_size] ^= e;
        ++j;
      };
      fclose(current_file);
    };
  };

/* On crit le xor, dans les fichiers casss. */

  for (j=0; j < nb_files_to_avoid; j++)
  {
    sprintf(file_name, "xor%d", file_to_avoid[j]);
    current_file = fopen(file_name, "w");
    for (k=0; k<file_size; k++)
      putc(swap[(k + file_size * file_to_avoid[j]) % swap_size], current_file);
    fclose(current_file);
    printf("Fichier %s reconstitu.\n", file_name);
  };

  return 0;
}

