/*
 * Nouvelle version de xorsplit.
 *
 * Sylvain Pion, Octobre 1996.
 */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>


int main(int argc, char **argv)
{
  signed int i, j, k, swap_size;
  FILE *current_file = NULL;
  unsigned char *swap, e;
  char file_name[32];
  int temp;
  int file_size = atoi(argv[1]);
  int xor_file_nb = atoi(argv[2]);

/* On alloue la memoire de travail. */

  swap_size = file_size * xor_file_nb;
  if ((swap = malloc(swap_size)) == NULL)
  {
    printf("Impossible d'allouer la memoire necessaire\n");
    exit(-1);
  };

/* On la met a zero. */

  for (i=0; i<swap_size; i++) swap[i]=0;

/* On fait la boucle de lecture. */

  i = 0;
  while ((temp = getc(stdin)) != EOF)
  {
    e = temp;
    swap[i % swap_size] ^= e;
    if ((i % file_size) == 0)
    {
      if (i != 0) fclose(current_file);
      sprintf(file_name, "xor%d", i / file_size);
      current_file = fopen(file_name, "w");
    };
    putc(e, current_file);
    i++;
  };

/* On ferme le dernier fichier ouvert. */

  fclose(current_file);

/* On ecrit le xor, dans les fichiers suivants. */

  for (j=0; j < xor_file_nb; j++)
  {
    sprintf(file_name, "xor%d", j + 1 + (i-1) / file_size);
    current_file = fopen(file_name, "w");
    for (k=0; k<file_size; k++)
      putc(swap[k + file_size * j], current_file);
    fclose(current_file);
  };

  return 0;
}
